//Релиз от 04,08,2019
//Параметры в структуре от Watashi
//Рампа для низа
//Преднагрев 5 секунд 3% мощности
//управление включением/выключением пайки и переключением профилей с РС
//сохранение и загрузка профилей с/на диск PC
//не используется экран, только ПК

#include <EEPROM.h>

//Секция ПИД----------------------------------------------
float integra, integra2;
float e1, p1,d1,e2,p2,d2;
#define i_min 0.0//минимум И составляющей
#define i_max 100.0//максимум И составляющей

byte Setpoint1;
double Input1;
byte  Output1;
byte  Output2;
double Input2;
#define SENSOR_SAMPLING_TIME 250 //время чтения температуры и пересчёта ПИД(милисекунды)
#define COM_PORT_SAMPLE_TIME 1000//время передачи данных на РС
//-----------------------------------------------------------

//секция алгоритма Брезенхема--------------------------------
int er1 = 1;
int er2 = 1;
int reg1;
int reg2;
boolean out1;
boolean out2;
//-----------------------------------------------------------

//Секция кнопок, пинов подключеня-----------------------------------------
//RelayPin "1"-ВЕРХНИЙ нагреватель
//RelayPin "2"-НИЖНИЙ нагреватель
#define RelayPin1 9  //назначаем пин "ВЕРХНЕГО" нагревателя
#define RelayPin2 3  //назначаем пин "НИЖНЕГО" нагревателя

byte cancelSwitchPin = 19; //пин кнопки отмена или назад

//назначаем пины усилителя термопары MAX6675 "ВЕРХНЕГО" нагревателя   clk=sck cs=cs do=so
byte thermoCLK = 5;  //=sck
byte thermoCS = 6;   //=cs
byte thermoDO = 4;   //=so
//назначаем пины усилителя термопары MAX6675 "НИЖНЕГО" нагревателя clk=sck cs=cs do=so
byte thermoCLK2 = 5;  //=sck
byte thermoCS2 = 7;   //=cs
byte thermoDO2 = 4;   //=so

int cancelSwitchState = 0;
long ms_button = 0;

//------------------------------------------------------------------------

//Секция профиля----------------------------------------------------------
struct pr {  // основные поля профиля
byte profileSteps; //количество шагов профиля
byte Setpoint2;
byte rampRateStep[3]; //скорость роста температуры
byte dwellTimerStep[3]; //установленное время перехода на следующий шаг
byte temperatureStep[3]; //заданные температуры для шагов профиля ВИ
byte min_pwr_TOPStep[3];       //минимальная мощность верхнего нагревателя
byte max_pwr_TOPStep[3];       //максимальная мощность верхнего нагревателя
byte BottomRampRateStep;
byte kp1;
byte ki1;
byte kd1;
byte kp2;
byte ki2;
byte kd2;
byte tableSize;
byte min_pwr_BOTTOM;              //минимальная мощность нижнего нагревателя
byte max_pwr_BOTTOM;              //максимальная мощность нижнего нагревателя
};

byte SizeProfile = sizeof(pr); // длинна поля данных
pr profile;

byte currentProfile = 1;
byte currentStep = 1;
//------------------------------------------------------------------------

//Секция флагов-----------------------------------------------------------
boolean TopStart = false;
byte flag = 0;  //флаг для фиксации стартовой температуры
byte x=1;  //переменная для перехода на нужный шаг при горячей плате
boolean alarmOn = false;
//------------------------------------------------------------------------

//Секция переменных общего назначения-------------------------------------
byte SP2;
byte bottomTemp;
int startTemp;
byte setpointRamp;
int counter;
long previousMillis; //это для счетчиков
unsigned long nextRead1; //переменная для обновления текущей температуры
unsigned long nextRead2;
int tc1;
int tc2;
byte Secs=0;
unsigned long prev_millis=0;
int i = 0;
//------------------------------------------------------------------------

//секция ввода/вывода для ПЭВМ-----------------------------------------------
char buf[20];   //буфер вывода сообщений через сом порт
char buf1[70];  //буфер вывода праметров через сом порт
int b1,b2=0;
String ttydata; //принятая строка параметров с сом порта от ПЭВМ
//---------------------------------------------------------------------------

//these are the different states of the sketch. We call different ones depending on conditions
// ***** TYPE DEFINITIONS *****
typedef enum REFLOW_STATE:byte
{
  REFLOW_STATE_IDLE,
  REFLOW_STATE_PRE_HEATER,
  REFLOW_STATE_BOTTOM_STEP_RAMP,
  REFLOW_STATE_STEP_RAMP,
  REFLOW_STATE_TABLE_SIZE,
  REFLOW_STATE_STEP,
  REFLOW_STATE_STEP_DWELL,
  REFLOW_STATE_COMPLETE,
  REFLOW_STATE_ERROR
}
reflowState_t;

typedef enum REFLOW_STATUS:byte //this is simply to check if reflow should be running or not
{
  REFLOW_STATUS_OFF,
  REFLOW_STATUS_ON
}
reflowStatus_t;
reflowStatus_t reflowStatus;
reflowState_t reflowState;

void loadProfile()//this function loads whichever profile currentProfile variable is set to
{
   for (byte j=0; j<=SizeProfile-1; j++) { 
       EEPROM.get((currentProfile-1)*SizeProfile,profile);
   }
      sprintf (buf1, "PR%01d%01d%03d%03d%03d%02d%02d%02d%03d%03d%03d%03d%03d%03d%03d%03d%03d%03d%03d%03d%02d%02d%02d%02d%02d%02d%02d\r\n",
      profile.profileSteps %10, profile.tableSize %10, int(profile.Setpoint2), profile.min_pwr_BOTTOM, profile.max_pwr_BOTTOM, 
      (profile.rampRateStep[0]) %100,(profile.rampRateStep[1]) %100, (profile.rampRateStep[2]) %100,
      profile.temperatureStep[0],profile.temperatureStep[1],profile.temperatureStep[2],
      profile.min_pwr_TOPStep[0], profile.min_pwr_TOPStep[1], profile.min_pwr_TOPStep[2],
      profile.max_pwr_TOPStep[0],profile.max_pwr_TOPStep[1],profile.max_pwr_TOPStep[2],
      profile.dwellTimerStep[0],profile.dwellTimerStep[1],profile.dwellTimerStep[2],
      profile.kp2 %100,profile.kp1 %100, profile.ki2 %100,profile.ki1 %100,profile.kd2 %100,profile.kd1 %100,profile.BottomRampRateStep %100); 
      Serial.print(buf1);
      delay(100); 
SP2 = profile.Setpoint2;
 return;
}

void SaveProfile () {  //  сохранение текущего профиля
  for (byte j=0; j<=SizeProfile-1; j++) {
    EEPROM.put((currentProfile-1)*SizeProfile,profile);
  }
  }

void ParseParameters ()//парсер параметров
{
  String st;
  sprintf (buf, "TXRecive Params%02d\r\n",ttydata.length());
  Serial.print(buf);
  st = ttydata.substring(0,1); 
  profile.profileSteps = st.toInt();
  st = ttydata.substring(1,2); 
  profile.tableSize = st.toInt();
  st = ttydata.substring(2,5); 
  profile.Setpoint2 = st.toInt();
  st = ttydata.substring(5,8); 
  profile.min_pwr_BOTTOM = st.toInt();
  st = ttydata.substring(8,11); 
  profile.max_pwr_BOTTOM = st.toInt();
  for (byte i = 0; i < 3; i++) {
          st=ttydata.substring(11+i*2,13+i*2);
          profile.rampRateStep[i] = st.toInt();
          st=ttydata.substring(17+i*3,20+i*3);
          profile.temperatureStep[i] = st.toInt();
          st=ttydata.substring(26+i*3,29+i*3);
          profile.min_pwr_TOPStep[i] = st.toInt();
          st=ttydata.substring(35+i*3,38+i*3);
          profile.max_pwr_TOPStep[i] = st.toInt();
          st=ttydata.substring(44+i*3,47+i*3);
          profile.dwellTimerStep[i] = st.toInt();
        }
  st=ttydata.substring(53,55);
  profile.kp2 = st.toInt();
  st=ttydata.substring(55,57);
  profile.kp1 = st.toInt();
  st=ttydata.substring(57,59);
  profile.ki2 = st.toInt();
  st=ttydata.substring(59,61);
  profile.ki1 = st.toInt();
  st=ttydata.substring(61,63);
  profile.kd2 = st.toInt();
  st=ttydata.substring(63,65);
  profile.kd1 = st.toInt();
  st=ttydata.substring(65,67);
  profile.BottomRampRateStep = st.toInt();
  ttydata=""; 
  SaveProfile();
return;
}
 
void setup()
{
   Serial.begin(9600);
//setup reley pins as outputs
  
  pinMode(thermoCLK, OUTPUT);
  pinMode(thermoCLK2, OUTPUT);
  pinMode(thermoDO, INPUT);
  pinMode(thermoDO2, INPUT);
  pinMode(thermoCS, OUTPUT);
  pinMode(thermoCS2, OUTPUT);
  pinMode (cancelSwitchPin, INPUT_PULLUP); //подключен подтягивающий резистор
  pinMode(RelayPin1, OUTPUT);
  pinMode(RelayPin2, OUTPUT);  
   loadProfile();//вызов функции loadProfile для загрузки данных профиля из eeprom    
  nextRead1 = millis();
  attachInterrupt(0, Dimming, RISING); // настроить порт прерывания(0 или 1) 2й или 3й цифровой пин
}


void loop()
{
   
//Считываем состояние кнопок управления для обычных кнопок
  cancelSwitchState =!digitalRead(cancelSwitchPin);

  unsigned long currentMillis = millis();
  
//отключил бузер при нажатии на кнопки (нервирует), кому надо раскоментируйте ниже 6 строк
  //if (upSwitchState == HIGH || downSwitchState == HIGH || cancelSwitchState == HIGH || okSwitchState == HIGH)
  //{
     //tone(buzzerPin, 1045);
     //delay(100);
     //noTone(buzzerPin);
  //}
  if (reflowState == REFLOW_STATE_COMPLETE || alarmOn) {
    if (i < 2 && cancelSwitchState == LOW) {
      alarmOn = true;
     
      i++;
    }
    else {
      i = 0;
      alarmOn = false;
    }
  }

  switch (reflowState)
  {
    case REFLOW_STATE_IDLE:
     TopStart = false;
     currentStep = 1;
     counter = 0;
     setpointRamp = 0;
     x = 1;             //устанавливаем переменную в исходное состояние
     flag = 0;         //после остановки профиля сбрасываем флаг
     Output1=0;
     Output2=0;
//блок обработки данных с ПЭВМ--------------------------------------------------------------------
    b2=Serial.available();
    if (b2 > 0) {
     b1 = Serial.read();
    if ((b1 == 'P') ) {
      sprintf (buf, "TXSend Params\r\n");
      Serial.println(buf);
      delay(50);
      loadProfile();
    }
      if (b1=='N') {
      ttydata=ttydata+Serial.readString();
      sprintf (buf, "TXRecive Params%02d\r\n",b2);
      Serial.println(buf);
      Serial.println("TX"+ttydata);
      if (ttydata.length()==67) 
              {
                Serial.println("TXParsing...\r\n");
                ParseParameters();
              }
      if (ttydata.length()>67) 
      {
        Serial.print("TXERROR on reciever\r\n");
        ttydata="";
      }
     } 
     if (b1=='S') 
      {
        Serial.println("TXPC_Start");
       
        sprintf (buf, "SYNC\r\n"); 
        Serial.print(buf);
        bottomTemp=0;
        integra=0;
        integra2=0;
        p1=0;
        p2=0;
        d1=0;
        d2=0;
        reflowStatus = REFLOW_STATUS_ON;
        reflowState = REFLOW_STATE_TABLE_SIZE;
      }
      if (b1=='U') { currentProfile = currentProfile + 1;
                    if (currentProfile >= 6) currentProfile = 1;
                    loadProfile();//вызов функции loadProfile для загрузки данных профиля из eeprom    
                   }
      if (b1=='D') { currentProfile = currentProfile - 1;
                    if (currentProfile <= 0) currentProfile = 5;
                    loadProfile();//вызов функции loadProfile для загрузки данных профиля из eeprom    
                   }
   }  

      if (millis() > nextRead1)
      {
        // Read thermocouples next sampling period
        nextRead1 =millis()+ SENSOR_SAMPLING_TIME;
        Input1 = Input1*0.8 + 0.2*(max6675_read_temp (thermoCLK,thermoCS,thermoDO));
        Input2 = Input2*0.8 + 0.2*(max6675_read_temp (thermoCLK2,thermoCS2,thermoDO2));
        tc1 = Input1;
        tc2 = Input2;
      if (isnan(Input1)) Serial.println("TXTC1Error");
      if (isnan(Input2)) Serial.println("TXTC2Error");
      }
      
      if (millis() > nextRead2)
      {
       nextRead2 =millis()+ COM_PORT_SAMPLE_TIME;
       sprintf (buf, "OK%03d%03d%03d%03d%03d\r\n", (Output1), (Output2), tc1, tc2, (currentProfile)); 
      // Serial.print(buf); 
      }
      
   break;
      
      //фиксируем размер стола
    case REFLOW_STATE_TABLE_SIZE:
      if (profile.tableSize == 1) {
       
       }
      if (profile.tableSize == 2) {
      
       }
      if (profile.tableSize == 3) {
      
       }
       previousMillis = millis();
       reflowState = REFLOW_STATE_PRE_HEATER;
       
    break;

    case REFLOW_STATE_PRE_HEATER:
      Output2 = 3;
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>60)
      {
        ms_button =  millis();
        Output2=0;
        reflowState = REFLOW_STATE_COMPLETE;
      }
      if (millis() - previousMillis > 5000) 
        {
         Output2 = 0; 
         bottomTemp=tc2;
         reflowState = REFLOW_STATE_STEP_RAMP;
        }
      
    break;

//рампа для нижнего нагревателя
    case REFLOW_STATE_BOTTOM_STEP_RAMP:
      if ((currentMillis - previousMillis) > 1000 / (profile.BottomRampRateStep * 0.1)) //скорость роста температуры от 0.1с. до 3с.
       {
        previousMillis = currentMillis;
        
        if (setpointRamp<profile.Setpoint2) 
        {
          counter = counter + 1;
          setpointRamp = counter + startTemp;
          bottomTemp = setpointRamp; 
        }
        else bottomTemp = profile.Setpoint2;
       }
       if (Input2 >= profile.Setpoint2 )
       {
        counter = 0;
        reflowState = REFLOW_STATE_STEP_RAMP;        
       }
       if (cancelSwitchState == HIGH && ( millis() - ms_button)>60)
       {
        ms_button =  millis();
       
        reflowStatus = REFLOW_STATUS_OFF;
        reflowState = REFLOW_STATE_IDLE;
       }
    break;
      
//"Старт и процесс пайки", рост температуры с заданной скоростью
    case REFLOW_STATE_STEP_RAMP:
            
      if (tc1 >= SP2-5 && !TopStart) {TopStart = true; bottomTemp = profile.Setpoint2;}  //если температура низа вышла на уставку включаем верхний нагреватель
      
      if (TopStart == true){   // включен верхний нагреватель      
      if (flag == 0)           //фиксируем стартовую температуру
       {
        startTemp = tc1;
        flag = 1;
       }
//устанавливаем нужный шаг, до которой нагрета плата      
      if (startTemp > profile.temperatureStep[currentStep -1])
       {
        for (x=1; startTemp > profile.temperatureStep[currentStep - 1]; currentStep++) x++;
       }      
      if (currentStep > x && flag == 1)
       {
        flag = 0;
        startTemp = profile.temperatureStep[currentStep - 2];        
        flag = 1;
       }
             
//счётчик скорости роста температуры             
      if ((currentMillis - previousMillis) > 1000 / (profile.rampRateStep[currentStep - 1] * 0.1)) //скорость роста температуры от 0.1с. до 3с.
       {
        previousMillis = currentMillis;
        counter = counter + 1;
        setpointRamp = counter + startTemp;
        Setpoint1 = setpointRamp;
		    }
       } //закрывам скобку

else  {
        startTemp = tc2;
        reflowState = REFLOW_STATE_BOTTOM_STEP_RAMP;
      }

 
      if (setpointRamp >= profile.temperatureStep[currentStep - 1]) reflowState = REFLOW_STATE_STEP;//если достигли нужной температуры
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>50)
       {
        ms_button =  millis();
       
        reflowStatus = REFLOW_STATUS_OFF;
        reflowState = REFLOW_STATE_IDLE;
       }
      break;
      
    case REFLOW_STATE_STEP:
      Setpoint1 = profile.temperatureStep[currentStep - 1];
     if (Input1 >= profile.temperatureStep[currentStep - 1] )
       {
        counter = 0;
        reflowState = REFLOW_STATE_STEP_DWELL;        
       }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>60)
       {
        ms_button =  millis();
       
        reflowStatus = REFLOW_STATUS_OFF;
        reflowState = REFLOW_STATE_IDLE;
       }
      break;
//считаем время перехода на следующий шаг
    case REFLOW_STATE_STEP_DWELL:  
      if (currentMillis - previousMillis > 1000) 
       {        
        previousMillis = currentMillis;
        counter = counter + 1;
       }
       if (counter == profile.dwellTimerStep[currentStep - 1]) //если счётчик равен установленному времени
       {
      
        counter = 0;
        setpointRamp = 0;
       if (profile.profileSteps == currentStep) //если достигли последнего шага 
       {
          currentStep = 1;
          x = 1;      //устанавливаем переменную в исходное состояние
          flag = 0;   //после завершения профиля сбрасываем флаг
          reflowState = REFLOW_STATE_COMPLETE;
       }
      else //если шаг не последний
       {          
          currentStep++; //переходим на следующий шаг
          reflowState = REFLOW_STATE_STEP_RAMP;          
       }
        }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>60)
       {
        ms_button =  millis();
      
        reflowStatus = REFLOW_STATUS_OFF;
        reflowState = REFLOW_STATE_IDLE;
       }
      break;
//завершение пайки      
    case REFLOW_STATE_COMPLETE:
     
       if (b1=='E') {Serial.println("TXStop_PC"); b1=' ';} else Serial.println("TXStop");
      reflowStatus = REFLOW_STATUS_OFF;
      reflowState = REFLOW_STATE_IDLE;      
      TopStart=false;
      break;
     }
//включение нагревателей
    if (reflowStatus == REFLOW_STATUS_ON)
     {
      b2=Serial.available();
    if (b2 > 0) 
    {
     b1 = Serial.read();
     if (b1 == 'E') reflowState = REFLOW_STATE_COMPLETE;
    }
    if (millis() > nextRead1)
     {nextRead1 += SENSOR_SAMPLING_TIME;
      Input1 = Input1*0.8 + 0.2*(max6675_read_temp (thermoCLK,thermoCS,thermoDO));
      Input2 = Input2*0.8 + 0.2*(max6675_read_temp (thermoCLK2,thermoCS2,thermoDO2));
      if (reflowState != REFLOW_STATE_PRE_HEATER) Output2=Pid2(Input2,bottomTemp,profile.kp2,profile.ki2,profile.kd2);
      if (TopStart) Output1=Pid1(Input1,Setpoint1,profile.kp1,profile.ki1,profile.kd1);
      tc1 = Input1;
      tc2 = Input2;
			prev_millis = millis();
 	    sprintf (buf, "OK%03d%03d%03d%03d%03d\r\n", int(Output1), int(Output2), tc1, tc2,int(currentProfile)); // график ПК
     // Serial.println(buf);
      if (isnan(Input1)) Serial.println("TXTC1Error");
      if (isnan(Input2)) Serial.println("TXTC2Error");
     }
            
      if (tc1 == SP2-5){
      
      
       } 
      if (tc1 >= 250)
       {
      
         reflowStatus = REFLOW_STATUS_OFF;
         reflowState = REFLOW_STATE_IDLE;    
       }       
      if (!TopStart) Output1=0;    
       }
      else
       {
        digitalWrite(RelayPin1, LOW);
        digitalWrite(RelayPin2, LOW);
       }
  }
      
void Dimming()
{
  
  OutPWR_TOP();
  OutPWR_BOTTOM();

  if (Secs >= 100)
  {
    Serial.println(buf);
	  Secs=0;
  } 
  else 
  Secs++;

}

void OutPWR_TOP(){
       reg1 = Output1 + er1; //pwr- задание выходной мощности в %,в текущем шаге профиля, er- ошибка округления   
        if (reg1 < 50){
          out1 = LOW;
          er1 = reg1; // reg- переменная для расчетов
          }
        else {
          out1 = HIGH;
          er1 = reg1-100;
        }
       digitalWrite(RelayPin1,out1);//пин через который осуществляется дискретное управление   
       }
       
void OutPWR_BOTTOM(){
       reg2 = Output2 + er2; //pwr- задание выходной мощности в %, er- ошибка округления
        if (reg2 < 50){
          out2 = LOW;
          er2 = reg2; // reg- переменная для расчетов
        }
        else {
          out2 = HIGH;
          er2 = reg2-100;
        }
       digitalWrite(RelayPin2,out2);//пин через который осуществляется дискретное управление
       }
       
   byte Pid1(double temp, byte ust, byte kP, byte kI, byte kd) 
 {
        byte out = 0;
        static float ed = 0;
        e1 = (ust - temp); //ошибка регулирования
        p1 =  (kP * e1); //П составляющая
        integra = (integra < i_min) ? i_min : (integra > i_max) ? i_max : integra + (kI * e1)/1000.0; //И составляющая
        d1 = kd * (e1 - ed); //Д составляющая
        ed = e1;
        out = (p1 + integra + d1 < profile.min_pwr_TOPStep[currentStep - 1]) ? profile.min_pwr_TOPStep[currentStep - 1] : (p1 + integra + d1 > profile.max_pwr_TOPStep[currentStep - 1]) ? profile.max_pwr_TOPStep[currentStep - 1] : p1 + integra + d1;
        return out;
 }

byte Pid2(double temp, byte ust, byte kP, byte kI, byte kd) 
 {
        byte out = 0;
        static float ed = 0;
        e2 = (ust - temp); //ошибка регулирования
        p2 =  (kP * e2); //П составляющая
        integra2 = (integra2 < i_min) ? i_min : (integra2 > i_max) ? i_max : integra2 + (kI * e2)/1000.0; //И составляющая
        d2 = kd * (e2 - ed); //Д составляющая
        ed = e2;
        out = (p2 + integra2 + d2 < profile.min_pwr_BOTTOM) ? profile.min_pwr_BOTTOM : (p2 + integra2 + d2 > profile.max_pwr_BOTTOM) ? profile.max_pwr_BOTTOM : p2 + integra2 + d2;
        return out;
 }

double max6675_read_temp (int ck, int cs, int so)              
 {char i; 
    int tmp = 0; 
   digitalWrite(cs, LOW);//cs = 0;                            // Stop a conversion in progress 
   asm volatile
    (
     " nop"        "\n\t"
    );
   for (i=15;i>=0;i--)
    {  digitalWrite(ck, HIGH);
      asm volatile
    (
     " nop"        "\n\t"
    );
      if( digitalRead(so))
      tmp|=(1<<i);
    
  
      digitalWrite(ck, LOW);
    asm volatile
    (
     " nop"        "\n\t"
    );
    } 
   digitalWrite(cs, HIGH);
   if (tmp & 0x4) {
     return NAN; 
   } else 
   return ((tmp>>3))*0.25;
 }
